/* player.c */

#include <sys/iocs.h>
#include <xsp2lib.h>

#include "main.h"
#include "player.h"
#include "shot.h"
#include "eshot.h"
#include "effect.h"
#include "txfont.h"
#include "sound.h"

#define PLAYER_BANK1	8	/* Xp^[ֈڍs܂ł̒l */
#define PLAYER_BANK2	12	/* ԌXp^[ֈȉ */

#define PLAYER_SPEED	15	/* @̑x */
#define PLAYER_PALET		0x0500	/* @̃pbg */
#define PLAYER_PALET_FLASH	0x0D00

#define PLAYER_START_X	144	/* @o̍W */
#define PLAYER_START_Y	(256+32)

#define PLAYER_MINX		(16+8)	/* X Wŏl */
#define PLAYER_MAXX		(16+255-8)
#define PLAYER_MINY		(16+16)		/* Y Wŏl */
#define PLAYER_MAXY		(16+255-12)

#define	TIME_MUTEKI	150	/* oꎞ̖G */

enum {
	PLAYER_PT_RIGHT2 = 0,	/* @ԉEɌXĂ鎞̃p^[ */
	PLAYER_PT_RIGHT1,	/* @V@EɁ@@@@@V@@@@@ */
	PLAYER_PT_CENTER,	/* @V@ʂĂ鎞̃p^[ */
	PLAYER_PT_LEFT1,	/* @EɌXĂ鎞̃p^[ */
	PLAYER_PT_LEFT2		/* @V@ԉEɁ@@@@@V@@@@@ */
};



/* c@\ */
void DispRest (void)
{
	short h;

#define REST_DISP_X	2
#define REST_DISP_Y	1
	TxfontCursor (REST_DISP_X, REST_DISP_Y);
	for (h = 0; h < 10; h++) {
		if (h < player->rest - 1)
			TxfontPutchar ('i');	/* 'i' Ɏ@̃}[N蓖ĂĂ܂ */
		else
			TxfontPutchar (' ');
	};
}



/* Q[JnɌĂ΂ */
void PlayerInit (void)
{
}



/* vC[oɌĂ΂ */
void PlayerAlloc (void)
{
	player->lx = PLAYER_START_X * 65536;
	player->ly = PLAYER_START_Y * 65536;
	player->status = PLAYER_STATUS_APPEAR;	/* oԂ */
	player->counter = 0;
	player->muteki = TIME_MUTEKI;
	player->flash = 0;
	player->game_over = GAME_PLAY;

    /* RA֘A */
	player->core_info = PALET_CORE_BLUE | PRIORITY_PLAYER;
	player->core_pt = sp_core + 1;
}



/* @Ă鎞̈ړ */
static void PlayerMoveAlive (void)
{
	int j;			/* WCXeBbN̓ */

	j = _iocs_joyget (0);	/* WCXeBbNO */

#if	0
    /* [A] {^ꂽH */
	if ((j & 0b00100000) == 0)
		player->game_over = GAME_ABORT;		/* Q[I[o[ */
#endif

    /* [B] {^ꂽH */
	if ((j & 0b1000000) == 0)
		ShotAlloc ();

    /* @̏㉺ړ */
	switch (j & 0b0011) {
	case 0b0010:		/*  */
		if (player->ly >> 16 > PLAYER_MINY)
			player->ly += xytable[PLAYER_SPEED][192].y;
		break;
	case 0b0001:		/*  */
		if (player->ly >> 16 < PLAYER_MAXY)
			player->ly += xytable[PLAYER_SPEED][64].y;
		break;
	default:		/* ȊO */
		break;
	}

    /* @̍Eړ{EX */
	switch (j & 0b1100) {
	case 0b1000:		/*  */
		if (player->lx >> 16 > PLAYER_MINX)
			player->lx += xytable[PLAYER_SPEED][128].x;
		if (player->bank > 0) {
			player->bank = 0;
		} else {
			if (player->bank > -PLAYER_BANK2)
				player->bank--;
		}
		break;

	case 0b0100:		/* E */
		if (player->lx >> 16 < PLAYER_MAXX)
			player->lx += xytable[PLAYER_SPEED][0].x;
		if (player->bank < 0) {
			player->bank = 0;
		} else {
			if (player->bank < PLAYER_BANK2)
				player->bank++;
		}
		break;

	default:		/* ȊO */
	    /* @̌Xɖ߂ */
		if (player->bank != 0) {
			if (player->bank > 0)
				player->bank--;
			else
				player->bank++;
		}
		break;
	}

    /* @̌X (player->bank) 玩@̕XvCgNo.߂ */
	if (player->bank == 0) {
		player->pt = obj_player + PLAYER_PT_CENTER;
	} else {
		if (player->bank > 0) {
			if (player->bank < PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_LEFT1;
			else
				player->pt = obj_player + PLAYER_PT_LEFT2;
		} else {
			if (player->bank > -PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_RIGHT1;
			else
				player->pt = obj_player + PLAYER_PT_RIGHT2;
		}
	}
	player->x = player->lx / 65536;
	player->y = player->ly / 65536;

    /* eL[ */
	if ((j & 0b1111) == 0) {	/* [SELECT]+[START] */
		player->game_over = GAME_ABORT;
		return;
	}
	if (_iocs_bitsns (0x0c) & 0b10) {
	    /* [BREAK] */
		while (_iocs_bitsns (0x0c) & 0b10);
		player->game_over = GAME_ABORT;
		return;
	}
    /* |[Y */
	if ((_iocs_bitsns (0x00) & 0b10)	/* [ESC] */
	    ||((j & 0b1100) == 0)) {	/* Q[ [START] */
		pause_flag = !0;
		while ((_iocs_bitsns (0x00) & 0b10) || ((_iocs_joyget (0) & 0b1100) == 0));
		while ((!(_iocs_bitsns (0x00) & 0b10)) && (!((_iocs_joyget (0) & 0b1100) == 0)));
		while ((_iocs_bitsns (0x00) & 0b10) || ((_iocs_joyget (0) & 0b1100) == 0));
		pause_flag = 0;
	}
    /* GԂ̏ */
	player->info = PLAYER_PALET | PRIORITY_PLAYER;
	if (player->muteki) {
		player->muteki--;
		player->flash++;
		if (player->muteki > 55) {
		    /* oARcĂ̂őtbV */
			if (player->flash > 1) {
				player->info = PLAYER_PALET_FLASH | PRIORITY_PLAYER;
				player->flash = 0;
			}
		} else {
		    /* oAȂ̂ŒxtbV */
			if (player->flash > 5)
				player->info = PLAYER_PALET_FLASH | PRIORITY_PLAYER;
			if (player->flash > 10)
				player->flash = 0;
		}
	}
	xobj_set_st (player);	/* @\ */

    /* RA̕\ */
	player->core_x = player->x - 8;
	player->core_y = player->y - 8;
	xsp_set_st (&(player->core_x));
}


/* @񂾎̈ړ */
static void PlayerMoveDead (void)
{
	player->x = player->lx / 65536;
	player->y = player->ly / 65536;

    /* @̌Xɖ߂ */
	if (player->bank != 0) {
		if (player->bank > 0)
			player->bank--;
		else
			player->bank++;
	}
    /* @̌X (player->bank) 玩@̕XvCgNo.߂ */
	if (player->bank == 0) {
		player->pt = obj_player + PLAYER_PT_CENTER;
	} else {
		if (player->bank > 0) {
			if (player->bank < PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_LEFT1;
			else
				player->pt = obj_player + PLAYER_PT_LEFT2;
		} else {
			if (player->bank > -PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_RIGHT1;
			else
				player->pt = obj_player + PLAYER_PT_RIGHT2;
		}
	}

	player->info = PLAYER_PALET | PRIORITY_PLAYER;
	switch (player->counter++) {
	case 0:
	    /* 񂾂ƂȂ甚p^[o */
		EffectAlloc (EFFECT_EXPLPLAYER, 0, player->x, player->y);	/* p^[o */
		SoundSetSE (SE_PLAYER_EXPL);	/* vC[̔ */
		break;
	case 8 * 1:
	case 8 * 2:
	case 8 * 3:
	case 8 * 4:
	case 8 * 5:
		{
			signed short x, y;
			x = rndtable[(player->counter) & 0xff ^ 0x55] - 128;
			y = rndtable[(player->counter + 1) & 0xff ^ 0xaa] - 128;
		    /* player->counter ͗̎ƂĎgpĂ܂ */
			EffectAlloc (EFFECT_EXPLPLAYER, 0, player->x + x / 8, player->y + y / 8);
			SoundSetSE (SE_PLAYER_EXPL);	/* vC[̔ */
		}
		break;

	case 8 * 7:
	    /* Ṓuǂ[v */
		EffectAlloc (EFFECT_EXPLPLAYER, 0, player->x, player->y);
		SoundSetSE (SE_EXPL_L);
		player->x = 256 + 32;
		player->y = 256 + 32;
		break;
	case 8 * 12:
	    /* W */
		player->lx = PLAYER_START_X * 65536;
		player->ly = PLAYER_START_Y * 65536;
		player->status = PLAYER_STATUS_APPEAR;	/* oԂ */
		player->counter = 0;
		player->rest--;
		if (player->rest <= 0) {
			player->game_over = GAME_OVER;
		} else {
			if (!eshot_erase)
				eshot_erase = ESHOT_ERASE;	/* e */
		}
		DispRest ();	/* c@\ */
		break;

	default:
		if (player->counter < 55) {
			xobj_set_st (player);	/* @\ */
		    /* RA̕\ */
			player->core_x = player->x - 8;
			player->core_y = player->y - 8;
			xsp_set_st (&(player->core_x));
		}
		break;
	}
}



/* @񂾌̓oꏈ */
static void PlayerMoveAppear (void)
{
	player->bank = 0;
	player->pt = obj_player + PLAYER_PT_CENTER;
	player->ly -= (4 * 65536);

	player->x = player->lx / 65536;
	player->y = player->ly / 65536;

    /* @x܂Ői񂾂ʏԂ */
	if (player->y < 160) {
		player->status = PLAYER_STATUS_ALIVE;
		player->muteki = TIME_MUTEKI;
	}
	player->info = PLAYER_PALET | PRIORITY_PLAYER;
	if (player->flash++ > 1) {
		player->info = PLAYER_PALET_FLASH | PRIORITY_PLAYER;
		player->flash = 0;
	}
	xobj_set_st (player);	/* @\ */
    /* RA̕\ */
	player->core_x = player->x - 8;
	player->core_y = player->y - 8;
	xsp_set_st (&(player->core_x));
}



/* {X|̈ړ */
static void PlayerMoveComplete (void)
{
    /* @̌Xɖ߂ */
	if (player->bank != 0) {
		if (player->bank > 0)
			player->bank--;
		else
			player->bank++;
	}
    /* @̌X (player->bank) 玩@̕XvCgNo.߂ */
	if (player->bank == 0) {
		player->pt = obj_player + PLAYER_PT_CENTER;
	} else {
		if (player->bank > 0) {
			if (player->bank < PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_LEFT1;
			else
				player->pt = obj_player + PLAYER_PT_LEFT2;
		} else {
			if (player->bank > -PLAYER_BANK1)
				player->pt = obj_player + PLAYER_PT_RIGHT1;
			else
				player->pt = obj_player + PLAYER_PT_RIGHT2;
		}
	}

	player->info = PLAYER_PALET | PRIORITY_PLAYER;

	player->ly -= (4 * 65536);
	player->x = player->lx / 65536;
	player->y = player->ly / 65536;
	xobj_set_st (player);	/* @\ */
	if (player->y < -32)
		player->game_over = GAME_COMPLETE2;	/* Q[I */

    /* RA̕\ */
	player->core_x = player->x - 8;
	player->core_y = player->y - 8;
	xsp_set_st (&(player->core_x));
}



/* ƂɌĂ΂ */
void PlayerMove (void)
{
	if ((player->game_over == GAME_COMPLETE)
	    && (player->status == PLAYER_STATUS_ALIVE))
		player->status = PLAYER_STATUS_COMPLETE;

	switch (player->status) {
	case PLAYER_STATUS_ALIVE:
		PlayerMoveAlive ();
		break;
	case PLAYER_STATUS_DEAD:
		PlayerMoveDead ();
		break;
	case PLAYER_STATUS_APPEAR:
		PlayerMoveAppear ();
		break;
	case PLAYER_STATUS_COMPLETE:
		PlayerMoveComplete ();
		break;
	}
}
